#if SHADOWQUALITY > 0
uniform float shadowZExtendFar;
uniform float shadowRangeFar;
uniform mat4 toShadowMapSpaceMatrixFar;
out vec4 shadowCoordsFar;
#endif
#if SHADOWQUALITY > 1
uniform float shadowZExtendNear;
uniform float shadowRangeNear;
uniform mat4 toShadowMapSpaceMatrixNear;
out vec4 shadowCoordsNear;
#endif


const float transitionDistance = 10.0;


void calcShadowMapCoords(mat4 modelviewMat, vec4 worldPos) {
	float nearSub = 0;
#if SHADOWQUALITY > 0
#endif

#if SHADOWQUALITY > 1
	// Near map
	shadowCoordsNear = toShadowMapSpaceMatrixNear * worldPos;
	
	// Number black magic! (trial and error hackiness)
	float distanceNear = max(max(abs(worldPos.z) * 2, abs(worldPos.x)*1.4), abs(worldPos.y)*1.7);
	
	distanceNear = distanceNear - (shadowRangeNear - transitionDistance);
	distanceNear = distanceNear / transitionDistance;
	nearSub = shadowCoordsNear.w = clamp(1.0 - distanceNear, 0.0, 1.0);
#endif
#if SHADOWQUALITY > 0
	// Far map
	shadowCoordsFar = toShadowMapSpaceMatrixFar * worldPos;
	float distanceFar = max(max(abs(worldPos.z) * 2, abs(worldPos.x)*0.9), abs(worldPos.y)*1.4);

	distanceFar = distanceFar - (shadowRangeFar - transitionDistance);
	distanceFar = distanceFar / transitionDistance;
	shadowCoordsFar.w = max(0, clamp(1.0 - distanceFar, 0.0, 1.0) - nearSub);

#endif
}