#version 330 core

layout(location=0) in vec2 position;

uniform vec2 frameSize;
uniform int isVertical;

out vec2 texCoords[21];

void main(void)
{
    gl_Position = vec4(position, 0, 1);
    vec2 texCoord = (position + 1.0) / 2;
	
	if (isVertical == 1) {
		float pixelSize = 1.0 / frameSize[1];
		
		for (int i = -8; i < 8; i++) {
			texCoords[i + 8] = texCoord + vec2(0, pixelSize * i);
		}

	} else {
		float pixelSize = 1.0 / frameSize[0];
		
		for (int i = -8; i < 8; i++) {
			texCoords[i + 8] = texCoord + vec2(pixelSize * i, 0);
		}
	}
}