#version 330 core

in vec2 uv;
in vec4 color;
in float glowLevel;

out vec4 outColor;

uniform sampler2D tex2d;
uniform float noTexture;
uniform float alphaTest;
uniform int darkEdges;

void main () {
	if (darkEdges > 0) {
		float dx = 1.7 * abs(uv.x - 0.5) - 0.7;
		float dy = 1.7 * abs(uv.y - 0.5) - 0.7;
		float strength = clamp(max(dx,dy) * 0.85 + (1- (dx*dx + dy*dy)) * 0.15, 0, 0.5);
		
		outColor = vec4(0,0,0, strength);
		return;
	}

	if (noTexture > 0) {
		outColor = color;
	} else {
		outColor = texture(tex2d, uv) * color;
	}
	
	if (outColor.a <= alphaTest) discard;
}