#version 330 core
#extension GL_ARB_explicit_attrib_location: enable

layout(location = 0) in vec3 vertexPositionIn;
layout(location = 1) in vec2 uvIn;
layout(location = 2) in vec4 colorIn;

uniform vec4 rgbaIn;
uniform int extraGlow;
uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;
uniform int applyColor;

out vec2 uv;
out vec4 color;

void main(void)
{
	uv = uvIn;
	float glowLevel = extraGlow / 64.0;
	
	color = rgbaIn * (1 + glowLevel);
	if (applyColor == 1) color *= colorIn;
	
	
	gl_Position = projectionMatrix * modelViewMatrix * vec4(vertexPositionIn, 1.0);
}