#version 330 core
#extension GL_ARB_explicit_attrib_location: enable

in vec2 uv;
in vec4 color;
in float glowLevel;

layout(location = 0) out vec4 outColor;
layout(location = 1) out vec4 outGlow;

uniform sampler2D itemTex;
uniform float alphaTest = 0.001;

void main () {
	outColor = texture(itemTex, uv) * color;
	outColor.a = clamp(outColor.a, 0, 1); // No idea why, makes held torches glitchy without

	// Ensure held item always being in the front
	gl_FragDepth = gl_FragCoord.z / 10;
	
	if (outColor.a < alphaTest) discard;
	
	outGlow = vec4(glowLevel, 0, 0, outColor.a);  
}