#version 330 core
#extension GL_ARB_explicit_attrib_location: enable

in vec2 uv;
in vec4 color;
in vec4 rgbaFog;
in float fogAmount;
in float glowLevel;

layout(location = 0) out vec4 outColor;
layout(location = 1) out vec4 outGlow;

uniform sampler2D tex;
uniform float extraGodray = 0;
uniform float alphaTest = 0.001;

#include fogandlight.fsh

void main () {
  outColor = applyFogAndShadow(texture(tex, uv) * color, fogAmount);
  
  if (outColor.a < alphaTest) discard;

  outGlow = vec4(glowLevel, extraGodray, 0, outColor.a);
}